Bug 798907 - Make synctask scalable
Make synctask scalable
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: core (Show other bugs)
pre-release
Unspecified Unspecified
urgent Severity high
: ---
: ---
Assigned To: Amar Tumballi
Shwetha Panduranga
:
Depends On:
Blocks: 817967
  Show dependency treegraph
 
Reported: 2012-03-01 03:54 EST by Pranith Kumar K
Modified: 2013-12-18 19:07 EST (History)
3 users (show)

See Also:
Fixed In Version: glusterfs-3.4.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-24 14:00:53 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Pranith Kumar K 2012-03-01 03:54:07 EST
Description of problem:
At the moment, synctask uses task->frame to perform all the syncops, this will lead to high-memory usage if the task crawls millions of directories. i.e millions of STACK_WINDS/UNWINDS.

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
Comment 1 Amar Tumballi 2012-03-01 23:16:36 EST
patch submitted already... yet to be merged
Comment 2 Anand Avati 2012-03-10 01:19:38 EST
CHANGE: http://review.gluster.com/2850 (syncop: Make syntask scalable) merged in master by Vijay Bellur (vijay@gluster.com)
Comment 3 Anand Avati 2012-03-18 03:53:31 EDT
CHANGE: http://review.gluster.com/2902 (libglusterfs: Destroy stack_lock in STACK_DESTROY) merged in release-3.2 by Anand Avati (avati@redhat.com)
Comment 4 Shwetha Panduranga 2012-06-04 05:08:49 EDT
Test case:-
------------
1. create a replicate volume(1x3)
2. bring down 2 bricks
3. Create fuse/nfs mount
4. Create files ( 1 million files. files of different sizes )
5. Bring back the bricks.
6. execute "gluster volume heal <volume_name> full"

Expected Output:-
-----------------------
The memory consumption by glustershd process should not shoot up.
Comment 5 Shwetha Panduranga 2012-06-06 03:13:33 EDT
Verified the fix on 3.3.0qa45. Bug is fixed.

Note You need to log in before you can comment on or make changes to this bug.